//
//  LEManagedFile.m
//  CocoaFilesInCoreData
//
//  Created by Will Larson on 3/11/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "LEManagedFile.h"
#import "CocoaFilesInCoreData_AppDelegate.h"


@implementation LEManagedFile

+ (id)initFromPath: (NSString *)newPath withContext: (NSManagedObjectContext *)aContext {
    NSFileWrapper *newFileWrapper = [[NSFileWrapper alloc] initWithPath:newPath];
    
    CocoaFilesInCoreData_AppDelegate *delegate = [[NSApplication sharedApplication] delegate];
    NSString *supportFolder = [delegate applicationSupportFolder];
    NSString *pathToWrite = [NSString stringWithFormat: "%@/%@", supportFolder, [newFileWrapper filename]];
    if ([newFileWrapper writeToFile:pathToWrite atomically:YES updateFilenames:YES]==NO) {
        NSLog(@"Failed to copy file at %@ to %@", newPath, pathToWrite);
        return NO;
    }
    LEManagedFile *managedFile = 
        [NSEntityDescription insertNewObjectForEntityForName:@"OurFile"
                                      inManagedObjectContext:aContext];
    [managedFile setPath:pathToWrite];
    [aContext processPendingChanges];
    [newFileWrapper release];
    return [managedFile autorelease];
}

- (void) dealloc {
    [fileWrapper release];
    fileWrapper = nil;
    [super dealloc];
}
- (id)valueForKey: (NSString *)key {
    if ([key isEqualToString:@"icon"]==YES) {
        return [self icon];
    }
    else if ([key isEqualToString:@"filename"]==YES) {
        return [self filename];
    }
    else {
        return [super valueForKey:key];
    }
}

-(NSFileWrapper *)fileWrapper {
    if (fileWrapper == nil) {
        fileWrapper = [[NSFileWrapper alloc] initWithPath:[self path]];
    }
    return fileWrapper;
}
-(NSImage *)icon {
    return [[self fileWrapper] icon];
}
-(NSString *)filename {
    return [[self fileWrapper] filename];
}

-(NSString *)path {
    NSString * tmpValue;
    [self willAccessValueForKey: @"path"];
    tmpValue = [self primitiveValueForKey: @"path"];
    [self didAccessValueForKey: @"path"];
    return tmpValue;
}

-(void)setPath: (NSString *)newPath {
    [self willChangeValueForKey:@"path"];
    [self setPrimitiveValue:newPath forKey:@"path"];
    if (fileWrapper != nil) {
        [fileWrapper release];
        fileWrapper = nil;
    }
    [self didChangeValueForKey:@"path"];
}

@end
